package org.fuseri.moduleexercise.question;

import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.fuseri.moduleexercise.answer.Answer;
import org.fuseri.moduleexercise.common.DomainObject;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

/**
 * Represent Question entity
 */
@Getter
@Setter
@NoArgsConstructor
@Builder
public class Question extends DomainObject {

    private String text;

    private Set<Answer> answers = new HashSet<>();

    private String exerciseId;

    /**
     * Constructor of question
     *
     * @param text       question text
     * @param answers    question answers
     * @param exerciseId id of exercise the question belongs to
     */
    public Question(String text, Set<Answer> answers, String exerciseId) {
        this.text = text;
        this.answers = Objects.requireNonNullElseGet(answers, HashSet::new);
        this.exerciseId = exerciseId;
    }
}
